'
'  fastmenu GOLD (tm)  Copyright (c) 1991 By: Jack W Hildenbrand
'
'  If you use these routines or create applications to operate from
'  within fastmenu GOLD V3+ Alternate Applications MENU, you are asked to
'  register them with the author of fastmenu GOLD and donate a small
'  registration fee of $10.00 or donate a registered version of your
'  application and provide a shareware version so I can post it on the
'  fastbytes BBS along with fastmenu GOLD.
'
'  This is a demo showing how to call the two box drawing routines.
'
'  You may need to load QuickBASIC using the /AH switch if you increase the
'  size of the opening window.
'
DECLARE SUB DrawBar (x1%, y1%, x2%, y2%, ty%, c1%, c2%, c3%)
DECLARE SUB DrawButton (x1%, y1%, x2%, y2%, c1%, c2%, c3%, c4%, c5%)
DEFINT A-Z
    SCREEN 12       'Set screen mode to VGA 640x480 16 color
    x1 = 80                                                        'upper left column
    y1 = 90                                                        'upper left row
    x2 = 550                                                        'lower right column
    y2 = 330                                                        'lower right row
    p1 = x1                                                         'set p1 for put statement
    p2 = y1                                                         'set p2 for put statement
    Num1& = 4 + INT(((x2 - x1 + 8) * 1 + 7) / 8) * ((y2 - y1) + 8)  'calculate array size
    REDIM Hide(Num1&, 4)                                            'dimension the Hide array
    GET (x1, y1)-(x2 + 6, y2 + 6), Hide                                     'save the background image
    CALL DrawButton(x1, y1, x2, y2, 9, 8, 1, 11, 0)                   'draw the blue box
   
    REDIM Item$(11)
    FOR x = 1 TO 11
        Item$(x) = STRING$(21, " ")                                   'set all menu choices
    NEXT x                                                            'to a blank string
    Item$(1) = "Menu choice number #1"                 'title some of the
    Item$(2) = "Menu choice number #2"                 'menu choices
    Item$(4) = "Menu choice number #4"
    Item$(5) = "Menu choice number #5"
    Item$(7) = "Menu choice number #7"
   
    CALL DrawButton(90, 100, 400, 320, 7, 8, 0, 4, -1)                 'draw left black box
    LOCATE 8, 18: COLOR 12: PRINT "DEMO Application Interface"
    x = 1
    FOR y1 = 134 TO 294 STEP 16
        ty = 0
        IF Item$(x) = STRING$(21, " ") THEN ty = 1                  'if a menu choice is blank
        CALL DrawBar(100, y1, 390, y1 + 16, ty, 15, 8, 7)           'set bar to flat.
                                                                    'put print call here to display
                                                                    'menu option on the bar
        x = x + 1
    NEXT y1

    CALL DrawButton(410, 120, 530, 300, 7, 8, 0, 4, -1)               'draw right black box
    CALL DrawButton(420, 130, 520, 165, 12, 8, 4, 0, -1)              'draw red button
    CALL DrawButton(420, 166, 520, 201, 11, 8, 3, 0, -1)              'draw blue button
    CALL DrawButton(420, 202, 520, 237, 15, 8, 7, 0, -1)              'draw white button
  
    DO
    LOOP UNTIL INKEY$ <> ""                                         'pause loop
    CALL DrawButton(420, 130, 520, 165, 8, 12, 4, 0, -1)              'draw depressed red button
  
    CALL DrawBar(120, 120, 500, 300, 0, 15, 8, 7)
    CALL DrawBar(140, 140, 480, 200, 0, 8, 15, 7)
    CALL DrawBar(144, 164, 164, 196, 0, 15, 8, 7)
    CALL DrawBar(165, 164, 364, 196, 0, 15, 8, 7)
    CALL DrawBar(365, 164, 385, 196, 0, 15, 8, 7)
    CALL DrawBar(395, 149, 470, 190, 0, 8, 15, 7)
    CALL DrawBar(140, 220, 480, 280, 0, 8, 15, 7)
    CALL DrawButton(160, 235, 200, 265, 12, 8, 4, 0, -1)              'draw red button
    CALL DrawButton(201, 235, 241, 265, 10, 8, 2, 0, -1)              'draw white button


    DO
    LOOP UNTIL INKEY$ <> ""                                         'pause loop
    CALL DrawButton(160, 235, 200, 265, 8, 12, 4, 0, -1)              'draw depressed red button

    PUT (p1, p2), Hide, PSET                                        'replace background image
    ERASE Hide                                                      'erase Hide array from memory
    ERASE Item$                                                     'erase Item$ array
END

'
'  This routine draws a box or button on a vga screen in any size or
'  location and color.
'
'  Calling parameters
'
'        x1 = upper left column  \
'        x2 = lower right column  > pixel location   from 1 to 640
'        y1 = upper left row   \
'        y2 = lower right row   > pixel location   from 1 to 480
'        ty = button type; 0 = button out; 1 = flat button
'        c1 = left & top of box      \
'        c2 = right & bottom of box   > colors  from 0 to 15
'        c3 = face of button         /
'
SUB DrawBar (x1, y1, x2, y2, ty, c1, c2, c3) STATIC
    IF ty% = 0 THEN
        LINE (x1, y1)-(x2, y1), c1
        LINE (x1, y1 + 1)-(x1, y2 - 1), c1
        LINE (x2, y1 + 1)-(x2, y2 - 1), c2
        LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1), c2
        LINE (x1, y2 - 1)-(x2, y2 - 1), c2
        LINE (x1, y2 - 2)-(x2, y2 - 2), c2
        LINE (x1 + 1, y1 + 1)-(x2 - 2, y2 - 3), c3, BF
    ELSE
        LINE (x1, y1)-(x2, y1), c2
        LINE (x1, y1 + 1)-(x1, y2 - 1), c3
        LINE (x2, y1 + 1)-(x2, y2 - 1), c3
        LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1), c3
        LINE (x1, y2 - 1)-(x2, y2 - 1), c3
        LINE (x1, y2 - 2)-(x2, y2 - 2), c3
        LINE (x1 + 1, y1 + 1)-(x2 - 2, y2 - 3), c3, BF
    END IF
END SUB

'
'  This routine draws a box or button on a vga screen in any size or
'  location and color.
'
'  Calling parameters
'
'        x1 = upper left column  \
'        x2 = lower right column  > pixel location   from 1 to 640
'        y1 = upper left row   \
'        y2 = lower right row   > pixel location   from 1 to 480
'        ty = button type; 0 = button out; 1 = flat button
'        c1 = left & top of box      \
'        c2 = right & bottom of box   > colors  from 0 to 15
'        c3 = face of button         /
'        c4 = box frame            /
'        c5 = shadow     0 to 15;  -1 for no shadow
'
SUB DrawButton (x1, y1, x2, y2, c1, c2, c3, c4, c5) STATIC
    LINE (x1, y1)-(x2, y1), c1
    LINE (x1 + 1, y1 + 1)-(x2 - 1, y1 + 1), c1
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y1 + 2), c1
    LINE (x1, y1 + 1)-(x1, y2), c1
    LINE (x1 + 1, y1 + 2)-(x1 + 1, y2 - 1), c1
    LINE (x1 + 2, y1 + 3)-(x1 + 2, y2 - 2), c1
    LINE (x2, y1)-(x2, y2), c2
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1), c2
    LINE (x2 - 2, y1 + 2)-(x2 - 2, y2 - 2), c2
    LINE (x2 - 3, y1 + 3)-(x2 - 3, y2 - 3), c2
    LINE (x1, y2)-(x2, y2), c2
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1), c2
    LINE (x1 + 2, y2 - 2)-(x2 - 2, y2 - 2), c2
    LINE (x1 + 3, y2 - 3)-(x2 - 3, y2 - 3), c2
    LINE (x1 + 3, y1 + 3)-(x2 - 4, y2 - 4), c3, BF
    LINE (x1 + 6, y1 + 6)-(x2 - 7, y2 - 7), c4, B
    IF NOT c5 = -1 THEN
        LINE (x2 + 1, y1 + 6)-(x2 + 6, y2), c5, BF
        LINE (x1 + 6, y2 + 1)-(x2 + 6, y2 + 6), c5, BF
    END IF
END SUB

